(******************************************************************************)
(* buffered input                                                             *)
(* (C) 2009 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE BfdIn;

FROM SYSTEM IMPORT BYTE;

CONST
  maxLen = 64 * 1024;

  noBuffer = NIL;
  chrEOF = CHR( 1AH );  (* RdChar() *)

TYPE
  TBuffer;
  (* must return 0 only on eof (or requested = 0) *)
  TReadProc = PROCEDURE ( VAR ARRAY OF BYTE, CARDINAL ): CARDINAL;

PROCEDURE New( l: CARDINAL; p: TReadProc ): TBuffer;
PROCEDURE Dispose( b: TBuffer );

PROCEDURE RdBin(  b: TBuffer; VAR x: ARRAY OF BYTE; n: CARDINAL ): CARDINAL;
PROCEDURE RdChar( b: TBuffer ): CHAR;

END BfdIn.
