(******************************************************************************)
(* buffered output                                                            *)
(* (C) 2009 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE BfdOut;

FROM SYSTEM IMPORT BYTE;

CONST
  maxLen = 64 * 1024;

TYPE
  TBuffer;
  TWriteProc = PROCEDURE ( VAR ARRAY OF BYTE, CARDINAL );
(* The only way to tell mocka not to code open-array-copying is using VAR *)

  TEOL = (
    eolUnix,  (* 0A *)
    eolDos,   (* 0D, 0A *)
    eolMac    (* 0D *)
  );

CONST
  defPrefix = ' ';
  defChop   = FALSE;
  defEOL    = eolUnix;

  noBuffer = NIL;


PROCEDURE New( l: CARDINAL; p: TWriteProc ): TBuffer;
PROCEDURE Dispose( VAR b: TBuffer );
(* for debugging only: *)
PROCEDURE Flush( b: TBuffer );

PROCEDURE SetPrefix( b: TBuffer; c: CHAR );
PROCEDURE GetPrefix( b: TBuffer ): CHAR;
PROCEDURE SetChop(   b: TBuffer; x: BOOLEAN );
PROCEDURE GetChop(   b: TBuffer ): BOOLEAN;
PROCEDURE SetEOL(    b: TBuffer; x: TEOL );
PROCEDURE GetEOL(    b: TBuffer ): TEOL;

PROCEDURE WrBin(     b: TBuffer; VAR x: ARRAY OF BYTE; l: CARDINAL );
PROCEDURE WrStr(     b: TBuffer; s: ARRAY OF CHAR );
PROCEDURE WrChar(    b: TBuffer; c: CHAR );
PROCEDURE WrCharRep( b: TBuffer; c: CHAR; n: CARDINAL );
PROCEDURE WrStrAdj(  b: TBuffer; VAR s: ARRAY OF CHAR; l: INTEGER );

PROCEDURE WrShtCard( b: TBuffer; x: SHORTCARD; l: INTEGER );
PROCEDURE WrCard(    b: TBuffer; x: CARDINAL; l: INTEGER );
PROCEDURE WrLngCard( b: TBuffer; x: LONGCARD; l: INTEGER );

PROCEDURE WrShtHex(  b: TBuffer; x: SHORTCARD; l: INTEGER );
PROCEDURE WrHex(     b: TBuffer; x: CARDINAL; l: INTEGER );
PROCEDURE WrLngHex(  b: TBuffer; x: LONGCARD; l: INTEGER );

PROCEDURE WrLn(      b: TBuffer );

END BfdOut.
