(*
 * additional libc-based procedures
 *)
FOREIGN MODULE LibC;

TYPE
  TTime = INTEGER;		(* time_t, seconds since 1.1.1970 *)
  TDateTimeDesc = RECORD	(* struct tm *)
    sec,	(* seconds after the minute [0..60] *)
    min,	(* minutes after the hour [0..59] *)
    hour,	(* hours past midnight [0..23] *)
    mday,	(* day of month [1..31] *)
    month,	(* months since january [0..11] *)
    year,	(* years since 1900 *)
    wday,	(* days since sunday [0..6] *)
    yday,	(* days since 1.1. [0..365] *)
    isdst	(* daylight saving time *)
    : INTEGER;	(* int (4 bytes) *)
    (* for future use *)
    gmtoff: LONGINT;
    zone: POINTER TO CHAR;
  END;

PROCEDURE test0( x: LONGCARD );
PROCEDURE test1( VAR x: LONGCARD );
PROCEDURE test2(): INTEGER;

PROCEDURE GmTime( src: TTime; VAR dst: TDateTimeDesc );
PROCEDURE LocalTime( src: TTime; VAR dst: TDateTimeDesc );

(* src may become normalised *)
PROCEDURE MkTime( VAR src: TDateTimeDesc ): TTime;

END LibC.
