(******************************************************************************)
(* MD4 Message-Digest (rfc1320)  -  TopSpeed compatible                       *)
(* (C) 2009 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE MD4;

FROM SYSTEM IMPORT BYTE;

TYPE
  LONGBITSET = SET OF [ 0 .. 31 ];
  TStateDesc = RECORD
    a, b, c, d: LONGBITSET;
  END;
  TCntDesc = RECORD
    l, h: LONGCARD;
  END;
  TBufIdx = [ 0 .. 63 ];
  TBufDesc = ARRAY TBufIdx OF BYTE;

  TCtxDesc = RECORD
    st : TStateDesc;
    cnt: TCntDesc;       (* number of bits (MOD 2^64) processed *)
    buf: TBufDesc;       (* msg fragment *)
  END;

  TDgstIdx = [ 0 .. 15 ];
  TDgstDesc = ARRAY TDgstIdx OF BYTE;

  TDgstStrIdx = [ 0 .. 31 ];
  TDgstStr = ARRAY TDgstStrIdx OF CHAR;


PROCEDURE Init( VAR c: TCtxDesc );
PROCEDURE Update( VAR c: TCtxDesc; VAR x: ARRAY OF BYTE; l: CARDINAL );
PROCEDURE Final( VAR c: TCtxDesc; VAR d: TDgstDesc );

PROCEDURE MkStr( VAR s: TDgstStr; VAR d: TDgstDesc );
PROCEDURE MkDgst( VAR d: TDgstDesc; VAR s: ARRAY OF CHAR ): BOOLEAN;

END MD4.
