(******************************************************************************)
(* aMule met source scanner                                                   *)
(* (C) 2009..2010 Steffen Solyga <solyga@absinth.net>                         *)
(******************************************************************************)
DEFINITION MODULE TxtScnr;

IMPORT MD4;

TYPE
  TNameStr = ARRAY [ 0 .. 255 ] OF CHAR;
  TSymbol = (
    symNull,

    symNum,          (* 1 *)
    symStr,          (* 2 *)
    symDgst,         (* 3 *)

    symDash,         (* 4 *)
    symDDot,         (* 5 *)
    symLPar,         (* 6 *)
    symRPar,         (* 7 *)
    symEqu,          (* 8 *)
    symPlus,         (* 9 *)

    symKwKnown,      (* 10 *)
    symKwKnownLarge, (* 11 *)
    symKwPart,       (* 12 *)
    symKwFiles,      (* 13 *)
    symKwParts,      (* 14 *)
    symKwTags,       (* 15 *)

    symEOF           (* 16 *)
  );
  TPosDesc = RECORD
    o, l, c: LONGCARD;
  END;

  TString = ARRAY [ 0 .. 511 ] OF CHAR;	(* sync with Bin2Txt *)

VAR
  fn: TNameStr;
  sym: TSymbol;
  pos: TPosDesc;	(* start pos of sym *)
  num, hig: LONGCARD;
  str: TString;
  dgst: MD4.TDgstDesc;

PROCEDURE Open( fn: ARRAY OF CHAR );	(* empty -> stdin *)
PROCEDURE Read();
PROCEDURE Close();

END TxtScnr.
